require 'set'

module Nodesets
  class Nodeset < Set
    attr_reader :sorted
    def initialize(nodes = nil, sorted = false)
      @sorted = sorted
      nodes = Nodesets.parse_nodeset(nodes) if nodes && nodes.is_a?(String)
      #nodes = Nodesets.parse_nodeset(nodes) if nodes && (! nodes.is_a?(Set))
      super(nodes)
    end
    def merge(nodes)
      @sorted = false
      if nodes && (! nodes.is_a?(Set))
        nodes = if nodes.is_a?(Array)
          nodes.map {|x| Nodesets.parse_nodeset(x) }.flatten
        else
          Nodesets.parse_nodeset(nodes)
        end
      end
      super(nodes)
    end
    def subtract(nodes)
      @sorted = false
      nodes = Nodesets.parse_nodeset(nodes) if nodes && (! nodes.is_a?(Set))
      super(nodes)
    end
    def &(nodes)
      nodes = Nodesets.parse_nodeset(nodes) if nodes && (! nodes.is_a?(Set))
      super(nodes)
    end
    def ^(nodes)
      nodes = Nodesets.parse_nodeset(nodes) if nodes && (! nodes.is_a?(Set))
      self.class.new(super(nodes))
    end
    def human_sort
      if @sorted
        self
      else
        Nodesets::Nodeset.new(Nodesets::HumanSortableArray.new(self.to_a).human_sort, true)
      end
    end
    def human_sort!
      self.replace(human_sort)
      #replaced = self.replace(human_sort)
      #@sorted = true
      #replaced
    end
    def [](pos)
      self.human_sort! unless @sorted
      self.to_a[pos]
    end
    def fold
      Nodesets.make_nodeset(self)
    end
    def expand(sort: true)
      self.human_sort! if (! @sorted) && sort
      self.to_a
    end
  end
end
